/****************************************************************************/
/* Demoprogramm fr Selbstprogrammierung                                    */
/* DEMO.H			                V 1.0                                   */
/* Derklaration der Funktionsaufrufe aus der SelfProg.DLL					*/
/* Achtung: Statische Einbindung der DLL, keine dynamische Einbindung       */
/* Author     : Malte Wolters (Goldammer GmbH)                              */
/* Erstellt   : Februar 2001                                                */
/* nderungen : 01.03.2001     Fehler in DLL: 16-Bit Umschaltung auf        */
/*                             Quattro-Karten war fehlerhaft                */
/*							   Kommentare eingefgt							*/
/*              05.03.2004     dynamisches Laden der DLL als Comp.-Switch   */
/****************************************************************************/

#ifndef _MC4_SELF_DLL_
#define _MC4_SELF_DLL_ _MC4_SELF_DLL_

#include <windows.h>
#define DllImport   __declspec( dllimport ) __stdcall							// Import einer DLL-Funktion (STDCALL)

#define LoadDynamically															// Definitionen fr LoadLibrary/GetProcAddress anstelle statischer Bindung
//#undef LoadDynamically														// Definition fr statische Bindung, MC4SELF.LIB und ANZEIGE.LIB mssen eingebunden werden

#define _external extern "C"													// als externe Funktion

typedef struct
{ 
	char Name[32];
	char Serial[20];
	int AnzahlAD;
	int BitbreiteAD;
	int AnzahlDA;
	int BitbreiteDA;
	int AnzahlCT;
	int AnzahlTTL;
	int PortbreiteTTL;
	int AnzahlPWM;
} Flashdaten, *PFlashdaten;

typedef struct
{
	int LowBorder;
	int HighBorder;
} ESP;

typedef struct
{ 
	char Name[32];
	char Serial[20];
	int AnzahlAD;
	int BitbreiteAD;
	int AnzahlDA;
	int BitbreiteDA;
	int AnzahlCT;
	int AnzahlTTL;
	int PortbreiteTTL;
	int AnzahlPWM;
	int SE_Possible;
	int SE_Summe;
	int Dif_Possible;
	int Dif_Summe;
	int NumOfESB;
	ESP Eingangsbereiche[10];
	int NumOfGain;
	int Gain[4];
	int TaktBasis;
} FlashdatenEx, *PFlashdatenEx;

typedef struct 
{
	int USBWDM;
	int ReservedForFutureUse[7];
} EnhancedInformations, *PEnhancedInformations;


typedef struct
{
	int ICP;
	int AC;
	int Gain;
	int SE;
} ICPStruct, *PICPStruct;


#ifndef LoadDynamically
/*************************************/
/* Bei statischer Bindung werden hier*/
/* die Funktionen geladen. Definition*/
/* durch die H- und LIB-Dateien      */
/*************************************/
/* Messroutinen aus der SELFPROG.DLL */
/*************************************/
_external int DllImport LoadCard(int CardNr);
_external int DllImport OpenCard(int CardNr);
_external int DllImport SwitchCard(int CardNr);
_external int DllImport CloseCard(int CardNr);
_external int DllImport ReadFlashData(int CardNr, void* BufferPtr);
_external int DllImport ReadFlashDataEx(int CardNr, void* BufferPtr);
_external int DllImport GetEnhancedInformations(int CardNr, PEnhancedInformations DestinationPointer);
_external int DllImport ConfigCard(int Differenzmodus, int ADWandler, int DARange);

_external int DllImport CaptureOneChannel(int ChannelNumber, int Differenzmodus, int InputRange, void* ScaledValue, void* BinaryValue);
_external int DllImport CaptureOneChannelEx(int ChannelNumber, int Differenzmodus, int InputRange, int Gain, int Oversampling, int Bipolar,  double* ScaledValue, int* BinaryValue);
_external int DllImport ClearChannelLists(void);
_external int DllImport ClearChannelListsEx(int CardNr, int SWTakt, int SWSignalisierung);
_external int DllImport PrepareFilterEntry(int Channel, int Filtermode, int SampleFreq,
                                           double Freq1, double Freq2,
										   double Freq3, double Freq4,
										   double Passabsorption, double Stopbandattenuation,
										   int MaxOrder, int DesignMethod, int Filtertyp,
										   int Window, int Param1);
_external int DllImport Add_AD_Channel_to_ScanList(int ChannelNumber, int Oversampling, int Gain, int Bipolar);
_external int DllImport Add_Dig_Channel_to_ScanList(int ChannelNumber, int Typ);
_external int DllImport Add_CT_Channel_to_ScanList(int ChannelNumber);
_external int DllImport SetADFrequency(int FrequencyPerChannel);
_external int DllImport SetADFrequencyEx(int FrequencyPerChannel, double* ReelleFrequenz, int* Basisfrequenz);
_external int DllImport FinalInit(void);
_external int DllImport StartADCapture(void);
_external int DllImport StartADCaptureEx(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
_external int DllImport StopADCapture(void);
_external int DllImport GetScaledData(int InputRange, void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
_external int DllImport GetBinaryData(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
_external int DllImport GetADBufferStatus(int CardID, int* SampledValuesPerChannel);
_external int DllImport PutOneChannel(int ChannelNumber, int OutputRange, double ScaledValue);
_external int DllImport Add_DA_Channel_to_ScanList(int ChannelNumber);
_external int DllImport Add_DA_Channel_to_ScanListEx(int ChannelNumber, int Buffertype, int BufferSize);
_external int DllImport SetDAFrequency(int FrequencyPerChannel);
_external int DllImport StartDAOutput(void);
_external int DllImport StartDAOutputEx(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
_external int DllImport StopDAOutput(void);
_external int DllImport PutScaledData(int OutputRange, void* SourceBuffer, int NumberOfChannels, void* NumberPerChannel, int SkipLessData);
_external int DllImport PutBinaryData(void* SourceBuffer, int NumberOfChannels, void* NumberPerChannel, int SkipLessData);
_external int DllImport GetDAFreeBufferSpace(int CardID, int* FreeWordsPerChannel);

_external int DllImport SetDigitalDirection(int Channel, int Direction);
_external int DllImport ReadDigitalBit(int Channel, void* Value);
_external int DllImport WriteDigitalBit(int Channel, int Value);
_external int DllImport SetDigitalPortDirection(int StartChannel, int Bits, int Direction);
_external int DllImport ReadDigitalPort(int StartChannel, int Bits, int* Value);
_external int DllImport WriteDigitalPort(int StartChannel, int Bits, int Value);

// Zhlerfunktionen
_external int DllImport ConfigureCounterInput(int ChannelNumber, int Countermode, int PresetValue,
											  int FrequencyResolution,int Flanke,
											  int InkrementalSWReset, int InkrementalHWReset,
											  int InkrementalHWResetFlanke, int InkrementalInterpolation);
_external int DllImport ReadCounterValue(int ChannelNumber, void* Value);
// Pulsweitenausgabe
_external int DllImport PreparePWMOutput(int ChannelNumber, int BaseFrequency, int StartRatio);
_external int DllImport PrepareFMOutput(int ChannelNumber, int StartFrequency, int PulsWidthRatio);
_external int DllImport WriteNewPWMRatio(int ChannelNumber, int BaseFrequency, int Ratio);
_external int DllImport WriteNewFMRatio(int ChannelNumber, int Frequency, int PWRatio);

_external int DllImport GetMemoryMeasurementStatus(int CardID);
_external int DllImport GetScaledDataFromMemoryMeasurement(int CardID,
                                                           int InputRange,
														   int AnzahlKanaele,
														   int ValuesPerChannel,
														   void* Destination,
														   int SkipIfLessData,
														   int* TransferedWords);
_external int DllImport GetBinaryDataFromMemoryMeasurement(int CardID,
														   int AnzahlKanaele,
														   int ValuesPerChannel,
														   void* Destination,
														   int SkipIfLessData,
														   int* TransferedWords);
_external int DllImport PrepareExtTrigger(int CardID, int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
_external int DllImport StartMemoryMeasurement(int CardID, int AnzahlKanaele, int ValuesPerChannel, int FrequencyPerChannel);
_external int DllImport StartMemoryMeasurementEx(int CardID, int AnzahlKanaele, int ValuesPerChannel,
												 int FrequencyPerChannel, int UsualBlockSize);
_external int DllImport StopMemoryMeasurement(int CardID);
_external int DllImport DeInitMemoryMeasurement(int CardID);
_external int DllImport ReadMemoryMeasurementStatus(int CardID, int* UsedValues, int* FIFOSize);

_external int DllImport PrepareFilterEntry(int Channel,
										   int Filtermode,
										   int SampleFreq,
										   double Freq1,
										   double Freq2,
										   double Freq3,
										   double Freq4,
										   double Passabsorption,
										   double Stopbandattenuation,
										   int MaxOrder,
										   int DesignMethod,
										   int FilterTyp,
										   int Window,
										   int Param1);
_external int DllImport SetGlobalTriggerValues(int Pretrigger,
											   int Posttrigger,
											   int WaitForStartTrigger);
_external int DllImport PrepareTriggerEntry(int Channel,
											// Starttrigger
											int StartTriggerAktiv,
											double StartTriggerSchwelle1,
											double StartTriggerSchwelle2,
											int StartTriggerTyp,
											int StartTriggerAbStart,
											int StartTriggerMessung,
											int StartTriggerSetTTL,
											int StartTriggerTTLKlemme,
											int StartTriggerTTLStartzustand,
											int StartTriggerTTLFlanke,
											// Stoptrigger
											int StopTriggerAktiv,
											double StopTriggerSchwelle1,
											double StopTriggerSchwelle2,
											int StopTriggerTyp,
											int StopTriggerAbStart,
											int StopTriggerMessung,
											int StopTriggerSetTTL,
											int StopTriggerTTLKlemme,
											int StopTriggerTTLStartzustand,
											int StopTriggerTTLFlanke,
											// Generell
											int Retriggerbar);
_external int DllImport PrepareTriggerTakt(int Channel, int AnzahlWerteProTakt,double Schwellwert, int Schwellenart);
_external int DllImport PrepareFFTEntry(int Channel, int AnzahlPunkte, int Spektrum, double Gain,
										int Fensterfunktion, double Parameter);
_external int DllImport PreparePIDEntry(int Channel,
										double PAnteil,
										double IAnteil,
										double  DAnteil,
										int  Reglerart,
										double Gain,
										double Sollwert,
										double MinValue,
										double MaxValue,
										int  DAKanal,
										int SampleFreq);
_external int DllImport  GetFFTData(int KanalNrInListe, void* DestinationBuffer);
_external int DllImport  GetDLLVersion(char *VString, int* V1, int* V2, int* V3);

_external int DllImport  ProgramUserTimerFrequency(int CardID, int Delay_in_ms);
_external int DllImport  StartUserTimer(int CardID, int EventHandle);
_external int DllImport  StopUserTimer(int CardID);
_external int DllImport  ShowDebugNumber(int Number);



_external int DllImport  SendICPSettings(int CardID, void* ICPStruct);


_external int DllImport  ConfigureCounterInputEx( int ChannelNumber, int Countermode, int PresetValue,
												  int FrequencyResolutionOrBitWidth, int Flanke,
												  int InkrementalSWReset, int InkrementalHWReset,
												  int InkrementalHWResetFlanke, int InkrementalInterpolation,
												  int InkrementalResolution);
_external int DllImport  CT_AddChannel_To_CTScanlist(int ChannelNumber);
_external int DllImport  SetCTFrequency(double Frequency);
_external int DllImport  StartCTCapture(void);
_external int DllImport  StartCTCaptureEx(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
_external int DllImport  StopCTCapture(void);
_external int DllImport  CT_GetScaledData(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
_external int DllImport  CT_GetBinaryData(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
_external int DllImport  GetCTBufferStatus(int CardID, void* SampledValuesPerChannel);


_external int DllImport  DIN_AddChannel_To_DINScanlist(int ChannelNumber, int Typ);
_external int DllImport  SetDINFrequency(double Frequency);
_external int DllImport  StartDINCapture(void);
_external int DllImport  StartDINCaptureEx(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
_external int DllImport  StopDINCapture(void);
_external int DllImport  DIN_GetScaledData(void* Destination, void* ValuesPerChannel, int SkipIfLessData);
_external int DllImport  DIN_GetBinaryData(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
_external int DllImport  GetDINBufferStatus(int CardID, void* SampledValuesPerChannel);

_external int DllImport  SetMasterSlaveFunction(int CardID, int Modus);



#else
/*************************************/
/* Bei dynmischer Bindung werden hier*/
/* die Funktionstypen und Variablen  */
/* deklariert, weiterhin steht eine  */
/* einfache Laderoutine zur Verfgung*/
/*************************************/
/* Messroutinen aus der SELFPROG.DLL */
/*************************************/
typedef int (__stdcall* TLoadCard)(int CardNr);
typedef int (__stdcall* TOpenCard)(int CardNr);
typedef int (__stdcall* TSwitchCard)(int CardNr);
typedef int (__stdcall* TCloseCard)(int CardNr);
typedef int (__stdcall* TConfigCard)(int Differenzmodus, int ADWandler, int DARange);
typedef int (__stdcall* TClearChannelLists)(void);
typedef int (__stdcall* TFinalInit)(void);
typedef int (__stdcall* TReadFlashData)(int CardNr, void* BufferPtr);
typedef int (__stdcall* TReadFlashDataEx)(int CardNr, void* BufferPtr);
typedef int (__stdcall* TGetEnhancedInformations)(int CardNr, PEnhancedInformations DestinationPointer);


typedef int (__stdcall* TAdd_AD_Channel_to_ScanList)(int ChannelNumber, int Oversampling, int Gain, int Bipolar);
typedef int (__stdcall* TSetADFrequency)(int FrequencyPerChannel);
typedef int (__stdcall* TStartADCapture)(void);
typedef int (__stdcall* TStartADCaptureEx)(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
typedef int (__stdcall* TStopADCapture)(void);
typedef int (__stdcall* TGetScaledData)(int InputRange, void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
typedef int (__stdcall* TGetBinaryData)(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
typedef int (__stdcall* TCaptureOneChannel)(int ChannelNumber, int Differenzmodus, int InputRange, void* ScaledValue, void* BinaryValue);
typedef int (__stdcall* TCaptureOneChannelEx)(int ChannelNumber, int Differenzmodus, int InputRange, int Gain, int Oversampling, int Bipolar,  double* ScaledValue, int* BinaryValue);
typedef int (__stdcall* TAdd_Dig_Channel_to_ScanList)(int ChannelNumber, int Typ);
typedef int (__stdcall* TAdd_CT_Channel_to_ScanList)(int ChannelNumber);


typedef int (__stdcall* TPutOneChannel)(int ChannelNumber, int OutputRange, double ScaledValue);
typedef int (__stdcall* TAdd_DA_Channel_to_ScanList)(int ChannelNumber);
typedef int (__stdcall* TSetDAFrequency)(int FrequencyPerChannel);
typedef int (__stdcall* TStartDAOutput)(void);
typedef int (__stdcall* TStopDAOutput)(void);
typedef int (__stdcall* TPutScaledData)(int OutputRange, void* SourceBuffer, int NumberOfChannels, void* NumberPerChannel, int SkipLessData);
typedef int (__stdcall* TPutBinaryData)(void* SourceBuffer, int NumberOfChannels, void* NumberPerChannel, int SkipLessData);
typedef int (__stdcall* TAdd_DA_Channel_to_ScanListEx)(int ChannelNumber, int Buffertype, int BufferSize);
typedef int (__stdcall* TGetDAFreeBufferSpace)(int CardID, int* FreeWordsPerChannel);
typedef int (__stdcall* TStartDAOutputEx)(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);


typedef int (__stdcall* TSetDigitalDirection)(int Channel, int Direction);
typedef int (__stdcall* TReadDigitalBit)(int Channel, void* Value);
typedef int (__stdcall* TWriteDigitalBit)(int Channel, int Value);
typedef int (__stdcall* TSetDigitalPortDirection)(int StartChannel, int Bits, int Direction);
typedef int (__stdcall* TReadDigitalPort)(int StartChannel, int Bits, int* Value);
typedef int (__stdcall* TWriteDigitalPort)(int StartChannel, int Bits, int Value);


// Zhlerfunktionen
typedef int (__stdcall* TConfigureCounterInput)(int ChannelNumber, int Countermode, int PresetValue,
                               int FrequencyResolution,int Flanke,
                               int InkrementalSWReset, int InkrementalHWReset,
                               int InkrementalHWResetFlanke, int InkrementalInterpolation
                               );
typedef int (__stdcall* TReadCounterValue)(int ChannelNumber, void* Value);


// Pulsweitenausgabe
typedef int (__stdcall* TPreparePWMOutput)(int ChannelNumber, int BaseFrequency, int StartRatio);
typedef int (__stdcall* TPrepareFMOutput)(int ChannelNumber, int StartFrequency, int PulsWidthRatio);
typedef int (__stdcall* TWriteNewPWMRatio)(int ChannelNumber, int BaseFrequency, int Ratio);
typedef int (__stdcall* TWriteNewFMRatio)(int ChannelNumber, int Frequency, int PWRatio);


typedef int (__stdcall* TPrepareExtTrigger)(int CardID, int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
typedef int (__stdcall* TGetMemoryMeasurementStatus)(int CardID);
typedef int (__stdcall* TGetScaledDataFromMemoryMeasurement)(int CardID,
															 int InputRange,
															 int AnzahlKanaele,
															 int ValuesPerChannel,
															 void* Destination,
															 int SkipIfLessData,
															 int* TransferedWords);
typedef int (__stdcall* TStartMemoryMeasurement)(int CardID, int AnzahlKanaele, int ValuesPerChannel, int FrequencyPerChannel);
typedef int (__stdcall* TDeInitMemoryMeasurement)(int CardID);
typedef int (__stdcall* TStartMemoryMeasurementEx)(int CardID, int AnzahlKanaele, int ValuesPerChannel, int FrequencyPerChannel, int UsualBlockSize);
typedef int (__stdcall* TStopMemoryMeasurement)(int CardID);
typedef int (__stdcall* TGetBinaryDataFromMemoryMeasurement)(int CardID,
															 int AnzahlKanaele,
															 int ValuesPerChannel,
															 void* Destination,
															 int SkipIfLessData,
															 int* TransferedWords);
typedef int (__stdcall* TReadMemoryMeasurementStatus)(int CardID, int* UsedValues, int* FIFOSize);


typedef int (__stdcall* TGetFFTData)(int KanalNrInListe, void* DestinationBuffer);


typedef int (__stdcall* TShowDebugNumber)(int Number);
typedef int (__stdcall* TGetDLLVersion)(char *VString, int* V1, int* V2, int* V3);


typedef int (__stdcall* TPrepareFilterEntry)(int Channel,
											 int Filtermode,
											 int SampleFreq,
											 double Freq1,
											 double Freq2,
											 double Freq3,
											 double Freq4,
											 double Passabsorption,
											 double Stopbandattenuation,
											 int MaxOrder,
											 int DesignMethod,
											 int FilterTyp,
											 int Window,
											 int Param1);
typedef int (__stdcall* TSetGlobalTriggerValues)( int Pretrigger, int Posttrigger, int WaitForStartTrigger);
typedef int (__stdcall* TPrepareTriggerEntry)(  int Channel,
												// Starttrigger
												int StartTriggerAktiv,
												double StartTriggerSchwelle1,
												double StartTriggerSchwelle2,
												int StartTriggerTyp,
												int StartTriggerAbStart,
												int StartTriggerMessung,
												int StartTriggerSetTTL,
												int StartTriggerTTLKlemme,
												int StartTriggerTTLStartzustand,
												int StartTriggerTTLFlanke,
												// Stoptrigger
												int StopTriggerAktiv,
												double StopTriggerSchwelle1,
												double StopTriggerSchwelle2,
												int StopTriggerTyp,
												int StopTriggerAbStart,
												int StopTriggerMessung,
												int StopTriggerSetTTL,
												int StopTriggerTTLKlemme,
												int StopTriggerTTLStartzustand,
												int StopTriggerTTLFlanke,
												// Generell
												int Retriggerbar);
typedef int (__stdcall* TPrepareTriggerTakt)(int Channel, int AnzahlWerteProTakt,double Schwellwert, int Schwellenart);
typedef int (__stdcall* TPrepareFFTEntry)(int Channel, int AnzahlPunkte, int Spektrum, double Gain, int Fensterfunktion, double Parameter);
typedef int (__stdcall* TPreparePIDEntry)(  int Channel,
											double PAnteil,
											double IAnteil,
											double  DAnteil,
											int  Reglerart,
											double Gain,
											double Sollwert,
											double MinValue,
											double MaxValue,
											int  DAKanal,
											int SampleFreq);


typedef int (__stdcall* TClearChannelListsEx)(int CardNr, int SWTakt, int SWSignalisierung);
typedef int (__stdcall* TSetADFrequencyEx)(int FrequencyPerChannel, double* ReelleFrequenz, int* Basisfrequenz);

typedef int (__stdcall* TProgramUserTimerFrequency)(int CardID, int Delay_in_ms);
typedef int (__stdcall* TStartUserTimer)(int CardID, int EventHandle);
typedef int (__stdcall* TStopUserTimer)(int CardID);

typedef int (__stdcall* TGetADBufferStatus)(int CardID, int* SampledValuesPerChannel);


typedef int (__stdcall* TSendICPSettings)(int CardID, void* ICPStruct);


typedef int (__stdcall* TConfigureCounterInputEx)(int ChannelNumber, int Countermode, int PresetValue,
												  int FrequencyResolutionOrBitWidth, int Flanke,
												  int InkrementalSWReset, int InkrementalHWReset,
												  int InkrementalHWResetFlanke, int InkrementalInterpolation,
												  int InkrementalResolution);
typedef int (__stdcall* TCT_AddChannel_To_CTScanlist)(int ChannelNumber);
typedef int (__stdcall* TSetCTFrequency)(double Frequency);
typedef int (__stdcall* TStartCTCapture)(void);
typedef int (__stdcall* TStartCTCaptureEx)(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
typedef int (__stdcall* TStopCTCapture)(void);
typedef int (__stdcall* TCT_GetScaledData)(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
typedef int (__stdcall* TCT_GetBinaryData)(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
typedef int (__stdcall* TGetCTBufferStatus)(int CardID, void* SampledValuesPerChannel);


typedef int (__stdcall* TDIN_AddChannel_To_DINScanlist)(int ChannelNumber, int Typ);
typedef int (__stdcall* TSetDINFrequency)(double Frequency);
typedef int (__stdcall* TStartDINCapture)(void);
typedef int (__stdcall* TStartDINCaptureEx)(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
typedef int (__stdcall* TStopDINCapture)(void);
typedef int (__stdcall* TDIN_GetScaledData)(void* Destination, void* ValuesPerChannel, int SkipIfLessData);
typedef int (__stdcall* TDIN_GetBinaryData)(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
typedef int (__stdcall* TGetDINBufferStatus)(int CardID, void* SampledValuesPerChannel);

typedef int (__stdcall* TSetMasterSlaveFunction)(int CardID, int Modus);








TLoadCard LoadCard;
TOpenCard OpenCard;
TSwitchCard SwitchCard;
TCloseCard CloseCard;
TReadFlashData ReadFlashData;
TReadFlashDataEx ReadFlashDataEx;
TGetEnhancedInformations GetEnhancedInformations;
TConfigCard ConfigCard;
TCaptureOneChannel CaptureOneChannel;
TCaptureOneChannelEx CaptureOneChannelEx;
TClearChannelLists ClearChannelLists;
TClearChannelListsEx ClearChannelListsEx;
TPrepareFilterEntry PrepareFilterEntry;
TAdd_AD_Channel_to_ScanList Add_AD_Channel_to_ScanList;
TAdd_Dig_Channel_to_ScanList Add_Dig_Channel_to_ScanList;
TAdd_CT_Channel_to_ScanList Add_CT_Channel_to_ScanList;
TSetADFrequency SetADFrequency;
TSetADFrequencyEx SetADFrequencyEx;
TFinalInit FinalInit;
TStartADCapture StartADCapture;
TStartADCaptureEx StartADCaptureEx;
TStopADCapture StopADCapture;
TGetScaledData GetScaledData;
TGetBinaryData GetBinaryData;
TGetADBufferStatus GetADBufferStatus;
TPutOneChannel PutOneChannel;
TAdd_DA_Channel_to_ScanList Add_DA_Channel_to_ScanList;
TAdd_DA_Channel_to_ScanListEx Add_DA_Channel_to_ScanListEx;
TSetDAFrequency SetDAFrequency;
TStartDAOutput StartDAOutput;
TStartDAOutputEx StartDAOutputEx;
TStopDAOutput StopDAOutput;
TPutScaledData PutScaledData;
TPutBinaryData PutBinaryData;
TGetDAFreeBufferSpace GetDAFreeBufferSpace;
TSetDigitalDirection SetDigitalDirection;
TReadDigitalBit ReadDigitalBit;
TWriteDigitalBit WriteDigitalBit;
TSetDigitalPortDirection SetDigitalPortDirection;
TReadDigitalPort ReadDigitalPort;
TWriteDigitalPort WriteDigitalPort;
TConfigureCounterInput ConfigureCounterInput;
TReadCounterValue ReadCounterValue;
TPreparePWMOutput PreparePWMOutput;
TPrepareFMOutput PrepareFMOutput;
TWriteNewPWMRatio WriteNewPWMRatio;
TWriteNewFMRatio WriteNewFMRatio;
TGetMemoryMeasurementStatus GetMemoryMeasurementStatus;
TGetScaledDataFromMemoryMeasurement GetScaledDataFromMemoryMeasurement;
TGetBinaryDataFromMemoryMeasurement GetBinaryDataFromMemoryMeasurement;
TPrepareExtTrigger PrepareExtTrigger;
TStartMemoryMeasurement StartMemoryMeasurement;
TStartMemoryMeasurementEx StartMemoryMeasurementEx;
TStopMemoryMeasurement StopMemoryMeasurement;
TDeInitMemoryMeasurement DeInitMemoryMeasurement;
TReadMemoryMeasurementStatus ReadMemoryMeasurementStatus;
TSetGlobalTriggerValues SetGlobalTriggerValues;
TPrepareTriggerEntry PrepareTriggerEntry;
TPrepareTriggerTakt PrepareTriggerTakt;
TPrepareFFTEntry PrepareFFTEntry;
TPreparePIDEntry PreparePIDEntry;
TGetFFTData GetFFTData;
TGetDLLVersion GetDLLVersion;
TProgramUserTimerFrequency ProgramUserTimerFrequency;
TStartUserTimer StartUserTimer;
TStopUserTimer StopUserTimer;
TShowDebugNumber ShowDebugNumber;


TSendICPSettings SendICPSettings;

TConfigureCounterInputEx ConfigureCounterInputEx;
TCT_AddChannel_To_CTScanlist CT_AddChannel_To_CTScanlist;
TSetCTFrequency SetCTFrequency;
TStartCTCapture StartCTCapture;
TStartCTCaptureEx StartCTCaptureEx;
TStopCTCapture StopCTCapture;
TCT_GetScaledData CT_GetScaledData;
TCT_GetBinaryData CT_GetBinaryData;
TGetCTBufferStatus GetCTBufferStatus;

TDIN_AddChannel_To_DINScanlist DIN_AddChannel_To_DINScanlist;
TSetDINFrequency SetDINFrequency;
TStartDINCapture StartDINCapture;
TStartDINCaptureEx StartDINCaptureEx;
TStopDINCapture StopDINCapture;
TDIN_GetScaledData DIN_GetScaledData;
TDIN_GetBinaryData DIN_GetBinaryData;
TGetDINBufferStatus GetDINBufferStatus;

TSetMasterSlaveFunction SetMasterSlaveFunction;





// Handles der DLL
HINSTANCE DllHandle;

int LoadMC4SelfDll()
{	
	int LoadFlag = 0;
	DllHandle = LoadLibrary("MC4SELF.DLL");										// Try to load DLL
	if (DllHandle == NULL)														// If DLL can't be loaded
	{
		return -1;																// return negative value for indicate
	}

	if( (LoadCard					= (TLoadCard)				GetProcAddress(DllHandle,"LoadCard")) == NULL ) LoadFlag = -1;
	if( (OpenCard					= (TOpenCard)				GetProcAddress(DllHandle,"OpenCard")) == NULL ) LoadFlag = -1;
	if( (SwitchCard					= (TSwitchCard)				GetProcAddress(DllHandle,"SwitchCard")) == NULL ) LoadFlag = -1;
	if( (CloseCard					= (TCloseCard)				GetProcAddress(DllHandle,"CloseCard")) == NULL ) LoadFlag = -1;
	if( (ReadFlashData				= (TReadFlashData)			GetProcAddress(DllHandle,"ReadFlashData")) == NULL ) LoadFlag = -1;
	if( (ReadFlashDataEx			= (TReadFlashDataEx)		GetProcAddress(DllHandle,"ReadFlashDataEx")) == NULL ) LoadFlag = -1;
	if( (GetEnhancedInformations	= (TGetEnhancedInformations)GetProcAddress(DllHandle,"GetEnhancedInformations")) == NULL ) LoadFlag = -1;
	if( (ConfigCard					= (TConfigCard)				GetProcAddress(DllHandle,"ConfigCard")) == NULL ) LoadFlag = -1;
	if( (CaptureOneChannel			= (TCaptureOneChannel)		GetProcAddress(DllHandle,"CaptureOneChannel")) == NULL ) LoadFlag = -1;
	if( (CaptureOneChannelEx		= (TCaptureOneChannelEx)	GetProcAddress(DllHandle,"CaptureOneChannelEx")) == NULL ) LoadFlag = -1;
	if( (ClearChannelLists			= (TClearChannelLists)		GetProcAddress(DllHandle,"ClearChannelLists")) == NULL ) LoadFlag = -1;
	if( (ClearChannelListsEx		= (TClearChannelListsEx)	GetProcAddress(DllHandle,"ClearChannelListsEx")) == NULL ) LoadFlag = -1;
	if( (PrepareFilterEntry			= (TPrepareFilterEntry)		GetProcAddress(DllHandle,"PrepareFilterEntry")) == NULL ) LoadFlag = -1;
	if( (Add_AD_Channel_to_ScanList	= (TAdd_AD_Channel_to_ScanList)	GetProcAddress(DllHandle,"Add_AD_Channel_to_ScanList")) == NULL ) LoadFlag = -1;
	if( (Add_Dig_Channel_to_ScanList= (TAdd_Dig_Channel_to_ScanList)GetProcAddress(DllHandle,"Add_Dig_Channel_to_ScanList")) == NULL ) LoadFlag = -1;
	if( (Add_CT_Channel_to_ScanList	= (TAdd_CT_Channel_to_ScanList)	GetProcAddress(DllHandle,"Add_CT_Channel_to_ScanList")) == NULL ) LoadFlag = -1;
	if( (SetADFrequency				= (TSetADFrequency)			GetProcAddress(DllHandle,"SetADFrequency")) == NULL ) LoadFlag = -1;
	if( (SetADFrequencyEx			= (TSetADFrequencyEx)		GetProcAddress(DllHandle,"SetADFrequencyEx")) == NULL ) LoadFlag = -1;
	if( (FinalInit					= (TFinalInit)				GetProcAddress(DllHandle,"FinalInit")) == NULL ) LoadFlag = -1;
	if( (StartADCapture				= (TStartADCapture)			GetProcAddress(DllHandle,"StartADCapture")) == NULL ) LoadFlag = -1;
	if( (StartADCaptureEx			= (TStartADCaptureEx)		GetProcAddress(DllHandle,"StartADCaptureEx")) == NULL ) LoadFlag = -1;
	if( (StopADCapture				= (TStopADCapture)			GetProcAddress(DllHandle,"StopADCapture")) == NULL ) LoadFlag = -1;
	if( (GetScaledData				= (TGetScaledData)			GetProcAddress(DllHandle,"GetScaledData")) == NULL ) LoadFlag = -1;
	if( (GetBinaryData				= (TGetBinaryData)			GetProcAddress(DllHandle,"GetBinaryData")) == NULL ) LoadFlag = -1;
	if( (PutOneChannel				= (TPutOneChannel)			GetProcAddress(DllHandle,"PutOneChannel")) == NULL ) LoadFlag = -1;
	if( (Add_DA_Channel_to_ScanList = (TAdd_DA_Channel_to_ScanList)	GetProcAddress(DllHandle,"Add_DA_Channel_to_ScanList")) == NULL ) LoadFlag = -1;
	if( (Add_DA_Channel_to_ScanListEx = (TAdd_DA_Channel_to_ScanListEx)	GetProcAddress(DllHandle,"Add_DA_Channel_to_ScanListEx")) == NULL ) LoadFlag = -1;
	if( (SetDAFrequency				= (TSetDAFrequency)			GetProcAddress(DllHandle,"SetDAFrequency")) == NULL ) LoadFlag = -1;
	if( (StartDAOutput				= (TStartDAOutput)			GetProcAddress(DllHandle,"StartDAOutput")) == NULL ) LoadFlag = -1;
	if( (StartDAOutputEx			= (TStartDAOutputEx)		GetProcAddress(DllHandle,"StartDAOutputEx")) == NULL ) LoadFlag = -1;
	if( (StopDAOutput				= (TStopDAOutput)			GetProcAddress(DllHandle,"StopDAOutput")) == NULL ) LoadFlag = -1;
	if( (PutScaledData				= (TPutScaledData)			GetProcAddress(DllHandle,"PutScaledData")) == NULL ) LoadFlag = -1;
	if( (PutBinaryData				= (TPutBinaryData)			GetProcAddress(DllHandle,"PutBinaryData")) == NULL ) LoadFlag = -1;
	if( (GetDAFreeBufferSpace		= (TGetDAFreeBufferSpace)	GetProcAddress(DllHandle,"GetDAFreeBufferSpace")) == NULL ) LoadFlag = -1;
	if( (SetDigitalDirection		= (TSetDigitalDirection)	GetProcAddress(DllHandle,"SetDigitalDirection")) == NULL ) LoadFlag = -1;
	if( (ReadDigitalBit				= (TReadDigitalBit)			GetProcAddress(DllHandle,"ReadDigitalBit")) == NULL ) LoadFlag = -1;
	if( (WriteDigitalBit			= (TWriteDigitalBit)		GetProcAddress(DllHandle,"WriteDigitalBit")) == NULL ) LoadFlag = -1;
	if( (SetDigitalPortDirection	= (TSetDigitalPortDirection)GetProcAddress(DllHandle,"SetDigitalPortDirection")) == NULL ) LoadFlag = -1;
	if( (ReadDigitalPort			= (TReadDigitalPort)		GetProcAddress(DllHandle,"ReadDigitalPort")) == NULL ) LoadFlag = -1;
	if( (WriteDigitalPort			= (TWriteDigitalPort)		GetProcAddress(DllHandle,"WriteDigitalPort")) == NULL ) LoadFlag = -1;
	if( (ConfigureCounterInput		= (TConfigureCounterInput)	GetProcAddress(DllHandle,"ConfigureCounterInput")) == NULL ) LoadFlag = -1;
	if( (ReadCounterValue			= (TReadCounterValue)	GetProcAddress(DllHandle,"ReadCounterValue")) == NULL ) LoadFlag = -1;
	if( (PreparePWMOutput			= (TPreparePWMOutput)	GetProcAddress(DllHandle,"PreparePWMOutput")) == NULL ) LoadFlag = -1;
	if( (PrepareFMOutput			= (TPrepareFMOutput)	GetProcAddress(DllHandle,"PrepareFMOutput")) == NULL ) LoadFlag = -1;
	if( (WriteNewPWMRatio			= (TWriteNewPWMRatio)	GetProcAddress(DllHandle,"WriteNewPWMRatio")) == NULL ) LoadFlag = -1;
	if( (WriteNewFMRatio			= (TWriteNewFMRatio)	GetProcAddress(DllHandle,"WriteNewFMRatio")) == NULL ) LoadFlag = -1;
	if( (GetMemoryMeasurementStatus	= (TLoadCard)			GetProcAddress(DllHandle,"LoadCard")) == NULL ) LoadFlag = -1;
	if( (GetScaledDataFromMemoryMeasurement	= (TGetScaledDataFromMemoryMeasurement)	GetProcAddress(DllHandle,"GetScaledDataFromMemoryMeasurement")) == NULL ) LoadFlag = -1;
	if( (GetBinaryDataFromMemoryMeasurement	= (TGetBinaryDataFromMemoryMeasurement)	GetProcAddress(DllHandle,"GetBinaryDataFromMemoryMeasurement")) == NULL ) LoadFlag = -1;
	if( (PrepareExtTrigger			= (TPrepareExtTrigger)	GetProcAddress(DllHandle,"PrepareExtTrigger")) == NULL ) LoadFlag = -1;
	if( (StartMemoryMeasurement		= (TStartMemoryMeasurement)  GetProcAddress(DllHandle,"StartMemoryMeasurement")) == NULL ) LoadFlag = -1;
	if( (StartMemoryMeasurementEx	= (TStartMemoryMeasurementEx)GetProcAddress(DllHandle,"StartMemoryMeasurementEx")) == NULL ) LoadFlag = -1;
	if( (StopMemoryMeasurement		= (TStopMemoryMeasurement)	 GetProcAddress(DllHandle,"StopMemoryMeasurement")) == NULL ) LoadFlag = -1;
	if( (DeInitMemoryMeasurement	= (TDeInitMemoryMeasurement) GetProcAddress(DllHandle,"DeInitMemoryMeasurement")) == NULL ) LoadFlag = -1;
	if( (ReadMemoryMeasurementStatus= (TReadMemoryMeasurementStatus) GetProcAddress(DllHandle,"ReadMemoryMeasurementStatus")) == NULL ) LoadFlag = -1;
	if( (SetGlobalTriggerValues		= (TSetGlobalTriggerValues)  GetProcAddress(DllHandle,"SetGlobalTriggerValues")) == NULL ) LoadFlag = -1;
	if( (PrepareTriggerEntry		= (TPrepareTriggerEntry)	 GetProcAddress(DllHandle,"PrepareTriggerEntry")) == NULL ) LoadFlag = -1;
	if( (PrepareTriggerTakt			= (TPrepareTriggerTakt)	GetProcAddress(DllHandle,"PrepareTriggerTakt")) == NULL ) LoadFlag = -1;
	if( (PrepareFFTEntry			= (TPrepareFFTEntry)	GetProcAddress(DllHandle,"PrepareFFTEntry")) == NULL ) LoadFlag = -1;
	if( (PreparePIDEntry			= (TPreparePIDEntry)	GetProcAddress(DllHandle,"PreparePIDEntry")) == NULL ) LoadFlag = -1;
	if( (GetFFTData					= (TGetFFTData)			GetProcAddress(DllHandle,"GetFFTData")) == NULL ) LoadFlag = -1;
	if( (GetDLLVersion				= (TGetDLLVersion)		GetProcAddress(DllHandle,"GetDLLVersion")) == NULL ) LoadFlag = -1;
//	if( (ProgramUserTimerFrequency	= (TProgramUserTimerFrequency)GetProcAddress(DllHandle,"ProgramUserTimerFrequency")) == NULL ) LoadFlag = -1;
//	if( (StartUserTimer				= (TStartUserTimer)		GetProcAddress(DllHandle,"StartUserTimer")) == NULL ) LoadFlag = -1;
//	if( (StopUserTimer				= (TStopUserTimer)		GetProcAddress(DllHandle,"StopUserTimer")) == NULL ) LoadFlag = -1;
	if( (ShowDebugNumber			= (TShowDebugNumber)	GetProcAddress(DllHandle,"ShowDebugNumber")) == NULL ) LoadFlag = -1;

	if( (SendICPSettings			= (TSendICPSettings) 	GetProcAddress(DllHandle,"SendICPSettings")) == NULL ) LoadFlag = -1;
	if( (ConfigureCounterInputEx	= (TConfigureCounterInputEx) GetProcAddress(DllHandle,"ConfigureCounterInputEx")) == NULL ) LoadFlag = -1;
	if( (CT_AddChannel_To_CTScanlist= (TCT_AddChannel_To_CTScanlist) GetProcAddress(DllHandle,"CT_AddChannel_To_CTScanlist")) == NULL ) LoadFlag = -1;
	if( (SetCTFrequency				= (TSetCTFrequency)		GetProcAddress(DllHandle,"SetCTFrequency")) == NULL ) LoadFlag = -1;
	if( (StartCTCapture				= (TStartCTCapture)		GetProcAddress(DllHandle,"StartCTCapture")) == NULL ) LoadFlag = -1;
	if( (StartCTCaptureEx			= (TStartCTCaptureEx)	GetProcAddress(DllHandle,"StartCTCaptureEx")) == NULL ) LoadFlag = -1;
	if( (StopCTCapture				= (TStopCTCapture)		GetProcAddress(DllHandle,"StopCTCapture")) == NULL ) LoadFlag = -1;
	if( (CT_GetScaledData			= (TCT_GetScaledData)	GetProcAddress(DllHandle,"CT_GetScaledData")) == NULL ) LoadFlag = -1;
	if( (CT_GetBinaryData			= (TCT_GetBinaryData)	GetProcAddress(DllHandle,"CT_GetBinaryData")) == NULL ) LoadFlag = -1;
	if( (GetCTBufferStatus			= (TGetCTBufferStatus)	GetProcAddress(DllHandle,"GetCTBufferStatus")) == NULL ) LoadFlag = -1;

//	if( (DIN_AddChannel_To_DINScanlist= (TDIN_AddChannel_To_DINScanlist) GetProcAddress(DllHandle,"DIN_AddChannel_To_DINScanlist")) == NULL ) LoadFlag = -1;
//	if( (SetDINFrequency			= (TSetDINFrequency)	GetProcAddress(DllHandle,"SetDINFrequency")) == NULL ) LoadFlag = -1;
//	if( (StartDINCapture			= (TStartDINCapture)	GetProcAddress(DllHandle,"StartDINCapture")) == NULL ) LoadFlag = -1;
//	if( (StartDINCaptureEx			= (TStartDINCaptureEx)	GetProcAddress(DllHandle,"StartDINCaptureEx")) == NULL ) LoadFlag = -1;
//	if( (StopDINCapture				= (TStopDINCapture)		GetProcAddress(DllHandle,"StopDINCapture")) == NULL ) LoadFlag = -1;
//	if( (DIN_GetScaledData			= (TDIN_GetScaledData)	GetProcAddress(DllHandle,"DIN_GetScaledData")) == NULL ) LoadFlag = -1;
//	if( (DIN_GetBinaryData			= (TDIN_GetBinaryData)	GetProcAddress(DllHandle,"DIN_GetBinaryData")) == NULL ) LoadFlag = -1;
//	if( (GetDINBufferStatus			= (TGetDINBufferStatus)	GetProcAddress(DllHandle,"GetDINBufferStatus")) == NULL ) LoadFlag = -1;

	if( (SetMasterSlaveFunction		= (TSetMasterSlaveFunction)	GetProcAddress(DllHandle,"SetMasterSlaveFunction")) == NULL ) LoadFlag = -1;

	return LoadFlag;
}


int CloseMC4SelfDll()
{
	FreeLibrary( DllHandle );
	return 0;
}


#endif

#endif //_MC4_SELF_DLL_
